#include <stdio.h>
#include <stdlib.h>
#include "reseau.h"

#define SOURCE 26
#define DESTINATION 42
#define MAXRETRANSMISSION 10
#define FEMISSION  "flux1.dat"
#define FRECEPTION "flux2.dat"

int erreurcrc=0;

void envoyer(ttrame Trame)
/* Envoie la trame Trame vers la couche physique en rajoutant si ncessaire des erreurs */
{
  if ((erreurcrc!=0) && ((rand() % erreurcrc)==0))
  {
    Trame.CRC++;
    envoyer_vers_couche_physique(Trame);
    Trame.CRC--;
  }
  else envoyer_vers_couche_physique(Trame);
  return;
}

int main(int argc, char **argv)
/* Programme principal, argument optionnel : quantit d'erreurs */
{
  int compteur=MAXRETRANSMISSION;
  int AS,AD;
  ttampon TamponEmission;
  ttrame Trame;

  if (argc>1) erreurcrc=atoi(argv[1]);

  fprintf(stderr,"Initialisation du protocole 3, erreurcrc=%d\n",erreurcrc);
  initialise_couche_physique(FEMISSION, FRECEPTION);
  initialise_couche_reseau(SOURCE, DESTINATION);

  while (compteur!=0)
  {
    attendre(SIGEMIS);
    prendre_de_la_couche_reseau(&AS, &AD, &TamponEmission);
    construire_trame(AS, AD, TamponEmission, &Trame);
    fprintf(stderr,"Envoi de trame : %d->%d, %s\n",AS,AD,TamponEmission.info);
    envoyer(Trame);
    tempo();
    compteur=MAXRETRANSMISSION;
    while ((compteur>0) && !signale(SIGRECU))
    {
      attendre(SIGTEMPO | SIGRECU);
      if (signale(SIGTEMPO))
      {
        fprintf(stderr,"Timeout : %d\n",compteur);
        compteur--;
        fprintf(stderr,"Renvoi de trame : %d->%d, %s\n",AS,AD,TamponEmission.info);
        envoyer(Trame);
        tempo();
      }
    }
    if (signale(SIGRECU))
    {
      fprintf(stderr,"Trame acquitee\n");
      prendre_de_la_couche_physique(&Trame);
    }
  }
  fprintf(stderr,"Trop d'erreurs de retransmission\n");
  return(1);
}
